package test.apache.cxf.rest.service;

import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;

import javax.ws.rs.HttpMethod;

public class TestDownloadFileService {

	public static final String DOWNLOAD_FILE_LOCATION = "D:/Demo/test/";

	public static void main(String []args) {

		String httpURL = "http://localhost:8080/ApacheCXF-UP-DOWN-Zip-File/services/fileservice/download/zip";
		String responseString = testDownloadService(httpURL);
		System.out.println("responseString : " + responseString);
	}

	/**
	 * This method uses HttpURLConnection to invoke exposed Restful web service and returns the response string to the calling client
	 * @param requestParams
	 * @return
	 */
	public static String testDownloadService(String httpUrl) {

		// local variables
		URL url = null;
		HttpURLConnection httpURLConnection = null;
		String responseMessageFromServer = null;
		String responseString = null; 
		InputStream inputStream = null;
		OutputStream outputStream = null; 

		try {   

			// httpURLConnection
			url = new URL(httpUrl);
			httpURLConnection = (HttpURLConnection) url.openConnection();   
			httpURLConnection.setRequestMethod(HttpMethod.GET);   
			httpURLConnection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
			httpURLConnection.setRequestProperty("Accept", "application/zip");
			httpURLConnection.setDoOutput(true);

			System.out.println("Response code: " + httpURLConnection.getResponseCode());
			if (httpURLConnection.getResponseCode() == 200) {

				responseMessageFromServer = httpURLConnection.getResponseMessage();
				System.out.println("ResponseMessageFromServer: " + responseMessageFromServer);

				inputStream = httpURLConnection.getInputStream();
				outputStream = new FileOutputStream(DOWNLOAD_FILE_LOCATION + "MyZippedFile.zip");
				byte[] buffer = new byte[1024];
				int bytesRead;
				while ((bytesRead = inputStream.read(buffer)) != -1) {
					outputStream.write(buffer, 0, bytesRead);
				}
				responseString =  outputStream.toString();
				outputStream.close();

				responseString = "download success";
			}
			else {
				// do some actions
			}
		}
		catch(Exception  ex){
			ex.printStackTrace();
		}
		finally{
			httpURLConnection.disconnect();
		}
		return responseString; 
	}
}